<template>
  <div class="page-profile">
    <app-header :sticky="true" />
    <div class="app-body">
      <header class="profile-header">
        <photo-changer
          ref="photoChanger"
          label="تغییر عکس"
          :value="user.avatar"
          :upload-url="$config.api.baseUrl + '/avatar'"
          @upload-success="updateAvatar($event.avatar)"
        />
        <div class="profile-image" @click="$refs.photoChanger.labelClick()">
          <div
            v-if="user.avatar"
            class="the-img"
            :style="{ backgroundImage: `url(${user.avatar})` }"
          />
          <i v-else class="ic-user icon-avatar" />
        </div>
        <h5 class="profile-name">{{ user.name }} {{ user.family }}</h5>
        <button
          v-if="!loading"
          type="button"
          class="btn  btn-icon edit-btn"
          :class="editing ? 'btn-primary' : 'btn-white text-muted'"
          @click="editing = !editing"
        >
          <i v-if="editing" class="ic-close" />
          <i v-else class="ic-edit" />
        </button>
      </header>
      <form v-if="editing" class="profile-body" @submit.prevent="updateUser">
        <loader :loading="loading">
          <div class="list-item no-border">
            <i class="ic-user" />
            <span>
              <input
                v-model="form.name"
                v-validate="'required'"
                type="text"
                name="name"
                class="form-control"
                placeholder="نام"
                data-vv-as="نام"
              />
            </span>
          </div>
          <div class="list-item no-border">
            <i class="ic-user" />
            <span>
              <input
                v-model="form.family"
                v-validate="'required'"
                type="text"
                name="family"
                class="form-control"
                placeholder="نام خانوادگی"
                data-vv-as="نام خانوادگی"
              />
            </span>
          </div>
          <div class="list-item no-border">
            <i class="ic-tablet" />
            <span>
              <input
                v-model="form.mobile"
                v-validate="'mobile'"
                v-number.numeric
                :readonly="user.mobileActive"
                type="tel"
                name="mobile"
                class="form-control en ltr"
                placeholder="موبایل"
                data-vv-as="موبایل"
              />
            </span>
          </div>
          <div class="list-item no-border">
            <i class="ic-envelope" />
            <span>
              <input
                v-model="form.email"
                v-validate="'email'"
                :readonly="user.emailActive"
                type="email"
                name="email"
                class="form-control en ltr"
                placeholder="ایمیل"
                data-vv-as="ایمیل"
              />
            </span>
          </div>
          <div class="submit text-center mt-4">
            <button type="submit" class="btn btn-success px-5">ذخیره</button>
          </div>
        </loader>
      </form>
      <div v-else class="profile-body">
        <div class="list-item">
          <i class="ic-user" />
          <span>{{ user.name }} {{ user.family }}</span>
        </div>
        <div class="list-item">
          <i class="ic-tablet" />
          <span>{{ user.mobile || 'موبایل ثبت نشده' }}</span>
          <template v-if="user.mobile">
            <small v-if="user.mobileActive" class="text-success">
              {{ 'تایید شده' }}
            </small>
            <small
              v-else
              class="text-danger pointer"
              @click="verifyItem = 'mobile'"
            >
              {{ 'تایید نشده' }}
            </small>
          </template>
        </div>
        <div class="list-item">
          <i class="ic-envelope" />
          <span :class="{ en: user.email }">
            {{ user.email || 'ایمیل ثبت نشده' }}
          </span>
          <template v-if="user.email">
            <small v-if="user.emailActive" class="text-success">
              {{ 'تایید شده' }}
            </small>
            <small
              v-else
              class="text-danger pointer"
              @click="verifyItem = 'email'"
            >
              {{ 'تایید نشده' }}
            </small>
          </template>
        </div>
        <div
          class="list-item pointer"
          :class="{ pointer: !loading, 'loading loading-primary': loading }"
          @click="logout"
        >
          <i class="ic-logout-phone" />
          <span>خروج از حساب کاربری</span>
        </div>
      </div>
    </div>
    <verify-modal :item-name.sync="verifyItem" />
  </div>
</template>

<script>
import '../../assets/sass/pages/profile.scss'
import { mapState } from 'vuex'
import VerifyModal from './VerifyModal'
import PhotoChanger from '../helper/PhotoChanger'
export default {
  name: 'Profile',
  components: { PhotoChanger, VerifyModal },
  data() {
    return {
      editing: false,
      loading: false,
      verifyItem: null,
      form: {
        name: '',
        family: '',
        email: '',
        mobile: ''
      }
    }
  },
  computed: {
    ...mapState({ user: state => state.user.data })
  },
  watch: {
    editing(val) {
      if (val) this.copy(this.user, this.form)
    }
  },
  methods: {
    copy(from, to) {
      Object.keys(this.form).forEach(key => (to[key] = from[key]))
    },
    logout() {
      if (this.loading) return
      this.$store.dispatch('user/logout', { $vm: this }).then(() => {
        this.$router.replace({ name: 'home' })
      })
    },
    updateAvatar(avatar) {
      this.$store.commit('user/updateData', { ...this.user, avatar })
    },
    updateUser() {
      this.$store
        .dispatch('user/updateProfile', {
          $vm: this,
          $data: this.form
        })
        .then(() => {
          this.editing = false
          this.copy(this.form, this.user)
          this.$message.success('پروفایل شما به روز شد')
          this.$store.dispatch('user/getProfile', {
            $mainLoading: true,
            $force: true
          })
        })
    }
  }
}
</script>
